#!/usr/bin/env python
# -*- Mode: Python -*-
# vi:si:et:sw=4:sts=4:ts=4

import gi
gi.require_version('GstBase', '1.0')

from gi.repository import Gst, GObject, GstBase
Gst.init(None)

class SnowmixAudioSrc(Gst.Pipeline):
    __gstmetadata__ = ('testbin Python','Transform', \
                      'Simple testbin element written in python', 'Marianna S. Buschle')

    __gsttemplates__ = (Gst.PadTemplate.new("src",
                                           Gst.PadDirection.SRC,
                                           Gst.PadPresence.ALWAYS,
                                           Gst.Caps.new_any()))

    # Doesn't work either...
    #ip = GObject.Property(type=str, default='127.0.0.1')
    #port = GObject.Property(type=int, default=9999)

    __gproperties__ = {
        "window-duration": (float,
                   "Window Duration",
                   "Duration of the sliding window, in seconds",
                   0.01,
                   100.0,
                   5,
                   GObject.ParamFlags.READWRITE
                  ),
        "test-window-duration": (float,
                   "Window Duration",
                   "Duration of the sliding window, in seconds",
                   0.01,
                   100.0,
                   5,
                   GObject.ParamFlags.READWRITE
                  )
    }

    def __init__(self):
        Gst.Bin.__init__(self)
        Gst.info('hello xD')
        #print(self.ip)
        #print(self.port)
        testsrc = Gst.ElementFactory.make("audiotestsrc", "audio_source")
        self.add(testsrc)
        self.add_pad(Gst.GhostPad.new("src", list(testsrc.iterate_src_pads())[0]))

        self.window_duration = 5


    def do_get_property(self, prop):
        print('get',prop.name)
        if prop.name.endswith('window-duration'):
            return self.window_duration
        else:
            raise AttributeError('unknown property %s' % prop.name)

    def do_set_property(self, prop, value):
        print('set',prop.name)
        if prop.name == 'window-duration':
            self.window_duration = value
        else:
            raise AttributeError('unknown property %s' % prop.name)

GObject.type_register(SnowmixAudioSrc)
__gstelementfactory__ = ("snowmixaudiosrc", Gst.Rank.NONE, SnowmixAudioSrc)
